#include<iostream>
using namespace std;

#include<stdlib.h>

#define LEPSZE_SITO_DYNAMICZNA_ALOKACJA_PAMIECI

#ifndef LEPSZE_SITO_DYNAMICZNA_ALOKACJA_PAMIECI
const int MAX=100000;
//#define MAX 10000

//int MAX=1000;

size_t sito(size_t n, bool wypisac)
{
	int tab[MAX];
	size_t i;

	if (n <= 2)return 2;
	n--;
	if (n > MAX)
	{
		cout << "Poza zakresem obliczen\n";
		return 2;
	}
	for (i = 1; i < n; i += 2)
	{
		tab[i-1]=0;
		tab[i] = 1;
	}
	tab[0] = 1;//dla liczby 2
	tab[n - 1] = (n - 1) & 1; //gdy niewyzerowana caa tablica
	size_t pom = n / 2;

	for (i = 3; i <= pom; i += 2)
	{
		size_t index;
		for (int j = 3; j <= pom; j += 2)
		{
			index = i * j - 2;
			if (index >= n)break;
			tab[index] = 0;
		}
	}
	size_t max = 2;

	if (wypisac == 1)
	{
		for (i = 0; i < n; ++i)
		{
			if (tab[i])//!=0)
			{
				max = i + 2;
				cout << i + 2 << endl;
			}
		}
	}
	else
	{
		for (i = n - 1; tab[i] != 1; --i);
		max = i + 2;
	}
	return max;
}
#else //#if defined(LEPSZE_SITO_DYNAMICZNA_ALOKACJA_PAMIECI)
size_t sito(size_t n, bool wypisac)
{
	int* tab; //1.
	size_t i;

	if (n <= 2)return 2;
	n--;
	tab = new int[n]; //2.
	//tab = new (nothrow)int[n]; //2.
	//if (tab == nullptr)
	//{
	//	cerr << "Blad przydzialu pamieci\n";
	//	exit(1);
	//}

	for (i = 1; i<n; i += 2)
	{
		tab[i-1] = 0;
		tab[i]  = 1;
	}
	tab[0] = 1;//dla liczby 2
	tab[n - 1] = (n - 1) & 1; //gdy niewyzerowana caa tablica
	size_t pom = n / 2;

	for (i = 3; i <= pom; i += 2)
	{
		size_t index;
		for (size_t j = 3; j <= pom; j += 2)
		{
			index = i*j - 2;
			if (index >= n)break;
			tab[index] = 0;
		}
	}
	size_t max = 2;

	if (wypisac == 1)
	{
		for (i = 0; i<n; ++i)
		{
			if (tab[i])//!=0)
			{
				max = i + 2;
				cout << i + 2 << endl;
			}
		}
	}
	else
	{
		for (i = n - 1; tab[i] != 1; --i);
		max = i + 2;
	}
	delete[] tab; //3.
	return max;
}

#endif
